SystemOrganization addCategory: #SoftwareDesign!
SystemOrganization addCategory: #'SoftwareDesign-Algorithm'!
SystemOrganization addCategory: #'SoftwareDesign-Model'!

PolygonMorph subclass: #SDNavEdge
	instanceVariableNames: 'startNode endNode weights'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavEdge class methodsFor: 'instance creation' stamp: 'GNS 11/18/2012 12:21'!
createFrom: aSource to: aDestination withWeight: aWeight

	| edge |
	
	edge := SDNavEdge new.
	edge from: aSource.
	aSource edges add: edge.
	edge to: aDestination.
	edge weights: aWeight.		
	
	^ edge ! !

!SDNavEdge class methodsFor: 'instance creation' stamp: 'GNS 12/6/2012 13:18'!
newWithStartNode: aStartNode andEndNode: anEndNode withWeight: aWeight

	| anEdge |
	
	anEdge := self arrowPrototype.
	anEdge
		startNode: aStartNode;
		endNode: anEndNode;
		weights: aWeight.
	
	^ anEdge ! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/6/2012 13:48'!
applyInitialEdgeAppearance
	
	| verticesPoints |
	
	verticesPoints := self calculateEdgePoints.
	
	self
		color: Color black;
		borderColor: Color black;
		borderWidth: 2;
		verticesAt: 1 put: (verticesPoints at: 1);
		verticesAt: 2 put: (verticesPoints at: 2);
		lock;
		changed.! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:32'!
applyInitialLabelAppearance

	self label
		contents: self weights asString;
		fontName: self defaultFontName size: self defaultFontSize;
		center: self center + 10;
		lock;
		changed.
	! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:25'!
calculateEdgePoints

	| startPoint endPoint xDifference yDifference|
	
	startPoint := self startNode position.
	endPoint := self endNode position.
	
	xDifference := startPoint x - endPoint x.
	yDifference := startPoint y - endPoint y.
	(xDifference abs < yDifference abs ) 
		ifTrue:
			[(yDifference < 0) 
			ifTrue: 
				[startPoint := startNode bottomCenter.
				endPoint := endNode topCenter.]
			ifFalse:
				[startPoint := startNode topCenter.
				endPoint := endNode bottomCenter.]] 
		ifFalse: 
			[(xDifference < 0) 
			ifTrue: 
				[startPoint := startNode rightCenter.
				endPoint := endNode leftCenter.]
			ifFalse:
				[startPoint := startNode leftCenter.
				endPoint := endNode rightCenter.]].
		
		^ Array with: startPoint with: endPoint
		! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 11/20/2012 17:59'!
defaultFontName

	^ Preferences standardDefaultTextFont familyName! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 11/20/2012 18:00'!
defaultFontSize

	^ 10! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:26'!
drawEdge
	
	self applyInitialEdgeAppearance.! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:30'!
drawLabel

	| label |
	
	label := StringMorph contents: self weights asString.
	self
		addMorph: label;
		applyInitialLabelAppearance.
	! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:23'!
drawYourselfOn: aCanvas

	aCanvas addMorph: self.
	self	
		drawEdge;
		drawLabel.! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 12/6/2012 13:45'!
label
	
	^ self submorphs isEmpty ifFalse: [self submorphs first.].! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:31'!
resetYourselfOn: aCanvas
	
	self
		applyInitialEdgeAppearance;
		applyInitialLabelAppearance.! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:20'!
weights
	"Answer the copy of the weights"

	^ weights! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:52'!
weights: anObject
	"Set the value of weights"

	weights := anObject! !

Model subclass: #OtherSystemModel
	instanceVariableNames: 'on'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!OtherSystemModel methodsFor: 'as yet unclassified' stamp: 'GNS 11/28/2012 01:29'!
initialize

	super initialize.
	
	self on: true.! !

!OtherSystemModel methodsFor: 'accessing' stamp: 'GNS 11/28/2012 01:00'!
on
	"Answer the value of on"

	^ on! !

!OtherSystemModel methodsFor: 'accessing' stamp: 'GNS 11/28/2012 01:00'!
on: anObject
	"Set the value of on"

	on := anObject! !

!OtherSystemModel methodsFor: 'as yet unclassified' stamp: 'GNS 11/28/2012 01:31'!
step

	self on ifFalse: [^self ].
	
	Transcript show: 'Ich steppe.'.
		
	! !

!OtherSystemModel methodsFor: 'as yet unclassified' stamp: 'GNS 11/28/2012 01:31'!
wantsStepsIn: hisView
	
	^ true! !

Model subclass: #SDNavMainWindowModel
	instanceVariableNames: 'graph algorithm stepping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!SDNavMainWindowModel methodsFor: 'accessing' stamp: 'GNS 11/28/2012 00:20'!
algorithm
	"Answer the value of algorithm"

	^ algorithm! !

!SDNavMainWindowModel methodsFor: 'accessing' stamp: 'GNS 11/28/2012 00:20'!
algorithm: anObject
	"Set the value of algorithm"

	algorithm := anObject! !

!SDNavMainWindowModel methodsFor: 'accessing' stamp: 'GNS 11/28/2012 00:20'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavMainWindowModel methodsFor: 'accessing' stamp: 'GNS 11/28/2012 00:21'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SDNavMainWindowModel methodsFor: 'initilialization' stamp: 'GNS 11/28/2012 01:16'!
initialize

	super initialize.
	
	self stepping: false.! !

!SDNavMainWindowModel methodsFor: 'action-handling' stamp: 'GNS 11/28/2012 01:02'!
playAlgorithm
	
	self startStepping.
	! !

!SDNavMainWindowModel methodsFor: 'stepping' stamp: 'GNS 11/28/2012 01:15'!
startStepping
	
	self stepping: true.! !

!SDNavMainWindowModel methodsFor: 'stepping' stamp: 'GNS 11/28/2012 01:30'!
step
	
	self stepping ifFalse: [^ self].
	
	self algorithm step.
	
	self algorithm ended
		ifTrue: [self stopStepping.]
		ifFalse: [self startStepping.].! !

!SDNavMainWindowModel methodsFor: 'accessing' stamp: 'GNS 11/28/2012 01:14'!
stepping
	"Answer the value of stepping"

	^ stepping! !

!SDNavMainWindowModel methodsFor: 'accessing' stamp: 'GNS 11/28/2012 01:14'!
stepping: anObject
	"Set the value of stepping"

	stepping := anObject! !

!SDNavMainWindowModel methodsFor: 'stepping' stamp: 'GNS 11/28/2012 01:15'!
stopStepping
	
	self stepping: false.! !

!SDNavMainWindowModel methodsFor: 'stepping' stamp: 'GNS 11/28/2012 01:31'!
wantsStepsIn: hisView
	
	"Otherwise the view - in this case the SDNavMainWindow - won't step."
	^ true! !

Morph subclass: #SDNavAlgorithm
	instanceVariableNames: 'graph startNode endNode stepMethod ended'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavAlgorithm class methodsFor: 'instance creation' stamp: 'GNS 11/29/2012 01:15'!
on: aGraph from: theStartNode to: theEndNode

	| algorithm |

	algorithm := self new.
	algorithm
		graph: aGraph;
		startNode: theStartNode;
		endNode: theEndNode.
		
	^ algorithm.! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:23'!
doingNothing

	"Really doing nothing."! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/28/2012 00:16'!
ended
	"Answer the value of ended"

	^ ended! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/28/2012 00:16'!
ended: anObject
	"Set the value of ended"

	ended := anObject! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 12/2/2012 15:52'!
finishAlgorithm
	
	| mainWindow |
	self
		stepMethod: [self doingNothing.];
		ended: true;
		stopStepping.
	
	mainWindow := self owner.
	mainWindow algorithmFinished.! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:20'!
firstStep
	
	self subclassResponsibility.! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/29/2012 23:19'!
initialize
	
	super initialize.
	
	self
		initializeAppearance;
		initializeAlgorithm.
	"stepMethod: self firstStep."! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/28/2012 00:18'!
initializeAlgorithm
	
	self
		stepMethod: self firstStep;
		ended: false.! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/29/2012 23:20'!
initializeAppearance
	
	self color: Color transparent.
	
	! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/30/2012 02:13'!
isFinished
	"Answer the value of ended"

	^ ended! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/30/2012 03:12'!
isRunning
	"Answer the value of ended"

	^ ended not! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:23'!
nextStep: aMethodBlock
	
	"The short form for stepMethod:."
	self stepMethod: aMethodBlock.! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/30/2012 02:29'!
reset

	self initializeAlgorithm.! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 02:33'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 11:32'!
step
	
	self stepMethod value! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 10:48'!
stepMethod
	"Answer the value of stepMethod"

	^ stepMethod! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 00:39'!
stepMethod: aMethodBlock
	"Set the value of stepMethod"

	stepMethod := aMethodBlock! !

SDNavAlgorithm subclass: #SDNavDijkstraAlgorithm
	instanceVariableNames: 'distances visitedNodes unvisitedNodes predecessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
distances
	"Answer the value of distance"
	
	distances ifNil: [
		distances := Dictionary new.].
	
	^ distances! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/24/2012 01:24'!
execute

	"Step 1 - start"
	self distances at: self startNode put: 0.
	self unvisitedNodes add: self startNode.
	"Step 1 - end"
	
	"Step 2 - start"
	[self unvisitedNodes size > 0] whileTrue: [ | aNode |
	"Step 2 - end"
		
		"Step 3 - start"	
		aNode := self getMininumOfUnVisitedNodes.
		"Step 3 - end"
		
		"Step 4 - start"
		self visitedNodes add: aNode.
		self unvisitedNodes remove: aNode.
		"Step 4 - end"
		
		"Step 5 - start"
		self findMinimalDistances: aNode.
		"Step 5 - start"
		].
	
	"Step lastStep"! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
findMinimalDistances: aNode

	| unvisitedNeighbors |
	
	unvisitedNeighbors := self unvisitedNeighborsOf: aNode.
	unvisitedNeighbors do: [ :unvisitedNeighbor |
		
		| tempDistance |
		tempDistance := (self shortestDistanceOf: aNode) + (aNode distanceTo: unvisitedNeighbor).
		
		((self shortestDistanceOf: unvisitedNeighbor) > tempDistance ) ifTrue: [
			self distances at: unvisitedNeighbor put: tempDistance.
			self predecessors at: unvisitedNeighbor put: aNode.
			self unvisitedNodes add: unvisitedNeighbor.].
	].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:20'!
firstStep

	^ [self step1]! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
getMininumOfUnVisitedNodes
	
	| minimum |
	
	minimum := nil.
	
	self unvisitedNodes do: [ :unvisitedNode |
		minimum
			ifNil: [minimum := unvisitedNode.]
			ifNotNil: [
				((self shortestDistanceOf: unvisitedNode)
					< (self shortestDistanceOf: minimum)) ifTrue: [minimum := unvisitedNode.]].	].
	^ minimum! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 11:43'!
highlightNode: aNode

	self unhighlightAllNodes.
	aNode borderWidth: 4! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/28/2012 11:23'!
lastStep
	
	"Do nothing until now."
	Transcript
		show: '---------------------', String cr;
		show: 'Distances ', self distances asString, ' ', String cr;
		show: '---------------------', String cr.
		
	self updateCanvas.
	self unhighlightAllNodes.
	self showShortestPath.
	self finishAlgorithm.! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
predecessors
	"Answer the value of predecessors"

	predecessors ifNil: [
		predecessors := Dictionary new.].
	
	^ predecessors! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
shortestDistanceOf: aNode
	
	| distance |
	distance := self distances at: aNode ifAbsent: [ ^ 10000].
	^ distance.
	! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 12:33'!
showDistances

	self distances keysAndValuesDo: [:node :distance |
		node name: distance.].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/30/2012 02:19'!
showShortestPath
	
	| actNode preNode |
	endNode ifNotNil:[
		actNode := endNode.
		[actNode = startNode] whileFalse:
		[
			preNode := self predecessors at: actNode ifAbsent: [
				^ self].
			
			preNode edges do:[ :edge |
				edge endNode = actNode ifTrue:[
					edge borderWidth: 2.5.
					edge borderColor: Color green.
					edge changed.
					].
				].
			actNode := preNode.
		]. 
	].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 10:10'!
showUnvisitedNodes

	self unvisitedNodes do: [:node |
		node color: Color lightRed.].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 10:09'!
showVisitedNodes

	self visitedNodes do: [:node |
		node color: Color lightGreen.].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/28/2012 11:22'!
step1

	"Init"
	self distances at: self startNode put: 0.
	self unvisitedNodes add: self startNode.
	
	self updateCanvas.
	self unhighlightAllNodes.
	"self nextStep: [self step2.]."
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self nextStep: [self lastStep].].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/28/2012 11:22'!
step2

	"Visualizing what it this if means"
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self nextStep: [self lastStep.].].
		
	self updateCanvas.
		! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 11:17'!
step3

	"Choose closest unvisited node "
	
	"CloUnvNode means closestUnvisitedNode"
	| cloUnvNode |

	cloUnvNode := nil.
	
	self unvisitedNodes do: [ :unvisitedNode |
		cloUnvNode
			ifNil: [cloUnvNode := unvisitedNode.]
			ifNotNil: [
				((self shortestDistanceOf: unvisitedNode)
					< (self shortestDistanceOf: cloUnvNode)) ifTrue: [cloUnvNode := unvisitedNode.]].	].
	
	self updateCanvas.
	self highlightNode: cloUnvNode.
	self nextStep: [self step4: cloUnvNode.].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 09:59'!
step4: aNode

	"Visualizing what this "
	Transcript show: 'Step4 - UnvNodes '.self unvisitedNodes asString.
	
	self visitedNodes add: aNode.
	self unvisitedNodes remove: aNode.
	
	self updateCanvas.
	self nextStep: [self step5: aNode.].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/28/2012 11:21'!
step5: aNode

	"Visualizing what this "
	
	| unvisitedNeighbors |
	
	unvisitedNeighbors := self unvisitedNeighborsOf: aNode.
	unvisitedNeighbors do: [ :unvisitedNeighbor |
		
		| tempDistance |
		tempDistance := (self shortestDistanceOf: aNode) + (aNode distanceTo: unvisitedNeighbor).
		
		((self shortestDistanceOf: unvisitedNeighbor) > tempDistance ) ifTrue: [
			self distances at: unvisitedNeighbor put: tempDistance.
			self predecessors at: unvisitedNeighbor put: aNode.
			self unvisitedNodes add: unvisitedNeighbor.].
	].
	self updateCanvas.
	"self nextStep: [self step2.]."
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self nextStep: [self lastStep.].].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 11:42'!
unhighlightAllNodes

	self unvisitedNodes do: [:node |
		node borderWidth: 1].
	self visitedNodes do: [:node |
		node borderWidth: 1].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
unvisitedNeighborsOf: aNode

	| unvisitedNeighbors |
	
	unvisitedNeighbors := OrderedCollection new.
	
	aNode edges do: [ :anEdge |
		
		| destinationNode |
		destinationNode := anEdge endNode.
		
		(self visitedNodes includes: destinationNode) ifFalse: [
			unvisitedNeighbors add: destinationNode.].
		].
	
	^ unvisitedNeighbors  ! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
unvisitedNodes
	"Answer the value of unvisitedNodes"

	unvisitedNodes ifNil: [
		unvisitedNodes := Set new.].
	
	^ unvisitedNodes! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'bg 11/27/2012 10:10'!
updateCanvas

	self showDistances.
	self showVisitedNodes.
	self showUnvisitedNodes.! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
visitedNodes
	"Answer the value of visitedNodes"

	visitedNodes ifNil: [
		visitedNodes := Set new.].
	
	 ^ visitedNodes! !

SDNavAlgorithm subclass: #SDNavLittleAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/29/2012 02:10'!
firstStep

	^ [self sayHuhu].! !

!SDNavLittleAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/29/2012 23:16'!
initialize

	super initialize.
	
self color: Color transparent! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/22/2012 02:27'!
sayHello

	Transcript show: 'Hello'.
	
	self nextStepMethod: [self sayHuhu].! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/22/2012 02:28'!
sayHuhu

	Transcript show: 'Huhu'.
	
	self nextStepMethod: [self sayHello].! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/29/2012 02:08'!
step

	Transcript show: 'Huhu'.! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/29/2012 02:12'!
wantsSteps

	^ true.! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/29/2012 22:51'!
wantsStepsIn: aSystemWindow
	
	^ true! !

Morph subclass: #SDNavGraph
	instanceVariableNames: 'nodes myCanvas startNode endNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

SDNavGraph subclass: #SDNavBerlinSBahnGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavBerlinSBahnGraph methodsFor: 'initialization' stamp: 'GNS 11/20/2012 01:16'!
initialize

	super initialize.
	
	self initializeGraphStructure.! !

!SDNavBerlinSBahnGraph methodsFor: 'initialization' stamp: 'GNS 11/20/2012 01:18'!
initializeGraphStructure	
	
	| nodeA nodeB nodeC nodeD nodeE |
	
	nodeA := SDNavNode createWithName: 'NodeA'.
	nodeB := SDNavNode createWithName: 'NodeB'.   
	nodeC := SDNavNode createWithName: 'NodeC'.
	nodeD := SDNavNode createWithName: 'NodeD'.   
	nodeE := SDNavNode createWithName: 'NodeE'.
	
	nodeA addConnectionTo: nodeB withWeight: 1.
	nodeA addConnectionTo: nodeC withWeight: 1.
	nodeC addConnectionTo: nodeD withWeight: 1.
	nodeD addConnectionTo: nodeE withWeight: 1.
	nodeE addConnectionTo: nodeA withWeight: 1.   
	
	self
		addNode: nodeA;
		addNode: nodeB;
		addNode: nodeC;
		addNode: nodeD;
		addNode: nodeE.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:47'!
addNode: aNode

	self nodes add: aNode.! !

!SDNavGraph methodsFor: 'drawing' stamp: 'bg 11/20/2012 19:55'!
deselectAllNodes

	self nodes do: [:aNode | aNode select: false].! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/20/2012 16:49'!
drawEdges

	self nodes do: [ :aNode |
		aNode edges do: [:anEdge |
			anEdge drawYourselfOn: self myCanvas.].
		].
! !

!SDNavGraph methodsFor: 'drawing' stamp: 'bg 11/20/2012 18:32'!
drawNodes

	self nodes do: [ :aNode |
		aNode drawYourselfOn: self myCanvas.].! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/20/2012 00:56'!
drawYourselfOn: aMorph

	
	self myCanvas: aMorph;
		drawNodes;
		drawEdges.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavGraph methodsFor: 'initialization' stamp: 'GNS 12/2/2012 10:13'!
initialize

	super initialize.
	
	self color: Color transparent.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
myCanvas
	"Answer the value of myCanvas"

	^ myCanvas! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
myCanvas: anObject
	"Set the value of myCanvas"

	myCanvas := anObject! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/18/2012 15:43'!
nodes
	
	nodes ifNil: [
		nodes := OrderedCollection new.].
	
	^ nodes! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
nodes: anObject
	"Set the value of nodes"

	nodes := anObject! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 12/6/2012 11:29'!
resetEdges

	self nodes do: [ :aNode |
		aNode edges do: [:anEdge |
			anEdge resetYourselfOn: self myCanvas.].].
! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/30/2012 02:57'!
resetNodes

	self nodes do: [ :aNode |
		aNode resetYourselfOn: self myCanvas.].! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/30/2012 02:59'!
resetYourselfOn: aCanvas

	self
		resetNodes;
		resetEdges.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/27/2012 10:07'!
setSelectedAsEnd

	self nodes do: [:aNode | 
		aNode isSelected 
		ifTrue:[
			aNode borderColor: Color red.
			self endNode: aNode.]
		ifFalse:[
			(self startNode = aNode) 
			ifFalse:[
				aNode borderColor: Color black.
				]]]! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/27/2012 10:11'!
setSelectedAsStart

	self nodes do: [:aNode | 
		aNode isSelected 
		ifTrue:[
			aNode borderColor: Color green.
			self startNode: aNode.]
		ifFalse:[
			(self endNode = aNode) 
			ifFalse:[
				aNode borderColor: Color black.
				]]]! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

SDNavGraph subclass: #SDNavLittleSampleGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavLittleSampleGraph methodsFor: 'initialization' stamp: 'GNS 11/29/2012 01:42'!
initialize

	super initialize.
	
	self initializeGraphStructure.! !

!SDNavLittleSampleGraph methodsFor: 'initialization' stamp: 'bg 11/27/2012 22:22'!
initializeGraphStructure
	
	| nodeA nodeB nodeC |
	
	nodeA := SDNavNode createWithName: 'A' on: 10@6 in: self.
	nodeB := SDNavNode createWithName: 'B' on: 4@2 in: self.   
	nodeC := SDNavNode createWithName: 'C' on: 3@3 in: self.
	
	nodeA addConnectionTo: nodeB withWeight: 2.
	nodeA addConnectionTo: nodeC withWeight: 5.
	nodeB addConnectionTo: nodeC withWeight: 2.
	nodeB addConnectionTo: nodeA withWeight: 2.
	   
	
	self
		addNode: nodeA;
		addNode: nodeB;
		addNode: nodeC.
	
	! !

SDNavGraph subclass: #SDNavMediumSampleGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavMediumSampleGraph methodsFor: 'initialization' stamp: 'GNS 11/29/2012 01:42'!
initialize

	super initialize.
	
	self initializeGraphStructure.! !

!SDNavMediumSampleGraph methodsFor: 'initialization' stamp: 'GNS 11/29/2012 01:42'!
initializeGraphStructure
	
	| nodeA nodeB nodeC nodeD nodeE nodeF nodeG nodeH |
	
	nodeA := SDNavNode createWithName: 'A' on: 0.5@0.5 in: self.
	nodeB := SDNavNode createWithName: 'B' on: 2@3 in: self.   
	nodeC := SDNavNode createWithName: 'C' on: 5@2 in: self.
	nodeD := SDNavNode createWithName: 'D' on: 7@2 in: self.
	nodeE := SDNavNode createWithName: 'E' on: 10@5.5 in: self.
	nodeF := SDNavNode createWithName: 'F' on: 5@4 in: self.
	nodeG := SDNavNode createWithName: 'G' on: 0.5@5.5 in: self.
	nodeH := SDNavNode createWithName: 'H' on: 9@0.5 in: self.
	
	nodeA addConnectionTo: nodeB withWeight: 7.
	nodeA addConnectionTo: nodeC withWeight: 4.
	nodeA addConnectionTo: nodeH withWeight: 1.
	nodeA addConnectionTo: nodeG withWeight: 4.
	
	nodeB addConnectionTo: nodeG withWeight: 1.
	
	nodeC addConnectionTo: nodeB withWeight: 2.
	nodeC addConnectionTo: nodeD withWeight: 2.
	nodeC addConnectionTo: nodeF withWeight: 4.
	nodeC addConnectionTo: nodeG withWeight: 4.
	
	nodeD addConnectionTo: nodeE withWeight: 2.
	
	nodeE addConnectionTo: nodeC withWeight: 1.
		
	nodeF addConnectionTo: nodeE withWeight: 2.
	
	nodeG addConnectionTo: nodeF withWeight: 1.
	nodeG addConnectionTo: nodeE withWeight: 4.
	
	nodeH addConnectionTo: nodeC withWeight: 2.
	nodeH addConnectionTo: nodeD withWeight: 7.
	nodeH addConnectionTo: nodeE withWeight: 10.
	   
	
	self
		addNode: nodeA;
		addNode: nodeB;
		addNode: nodeC;
		addNode: nodeD;
		addNode: nodeE;
		addNode: nodeF;
		addNode: nodeG;
		addNode: nodeH.
	
	! !

SystemWindow subclass: #OtherSystemWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!OtherSystemWindow methodsFor: 'as yet unclassified' stamp: 'GNS 11/28/2012 01:29'!
activateStepping

	self model on: false.! !

!OtherSystemWindow methodsFor: 'as yet unclassified' stamp: 'GNS 11/28/2012 01:28'!
initialize

	| button |
	
	super initialize.
	
	self
		model: OtherSystemModel new.
		
	button := SimpleButtonMorph new.
   	button
		target: self;
		label: 'Press me';
		actionSelector: #activateStepping.
		
	self addMorph: button. ! !

SystemWindow subclass: #SDNavMainWindow
	instanceVariableNames: 'uiElements algorithm algorithmFactoryMethod graph currentlySelectedNode selectedStartNode selectedEndNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 01:55'!
addUIElement: anUIElement at: aKeySymbol 

	self uiElements at: aKeySymbol put: anUIElement.! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 00:08'!
algorithm
	"Answer the value of algorithm"

	^ algorithm! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 01:48'!
algorithm: anAlgorithm

	algorithm := anAlgorithm.
	self addMorph: anAlgorithm.
	algorithm stopStepping.! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 12/6/2012 10:38'!
algorithmCanPlay
	
	^ (self selectedStartNode isNil and: [self selectedEndNode isNil]) not! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 16:23'!
algorithmFactoryMethod
	"Answer the value of algorithmFactoryMethod"

	^ algorithmFactoryMethod! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 16:23'!
algorithmFactoryMethod: anObject
	"Set the value of algorithmFactoryMethod"

	algorithmFactoryMethod := anObject! !

!SDNavMainWindow methodsFor: 'api' stamp: 'GNS 11/30/2012 03:14'!
algorithmFinished

	self algorithm isRunning ifTrue: [(Exception new messageText: 'This should not happen') signal.].
	
	self algorithm stopStepping.
	self changePauseBtnToReplayBtn.! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 11/30/2012 02:10'!
changePauseBtnToPlayBtn

	(self uiElement: #PlayPauseBtn)
		label: 'Play';
		actionSelector: #playAlgorithm.! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 11/30/2012 02:25'!
changePauseBtnToReplayBtn

	(self uiElement: #PlayPauseBtn)
		label: 'Replay';
		actionSelector: #replayAlgorithm.! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 11/30/2012 02:08'!
changePlayBtnToPauseBtn

	(self uiElement: #PlayPauseBtn)
		label: 'Pause';
		actionSelector: #pauseAlgorithm.! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 12/6/2012 10:07'!
createAlgorithm

	^ self algorithm
		ifNil: [self algorithm: self algorithmFactoryMethod value.].! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 12/6/2012 09:58'!
createDijkstraAlgorithm

	^ SDNavDijkstraAlgorithm
		on: self graph
		from: self selectedStartNode
		to: self selectedEndNode
	! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 11:35'!
currentlySelectedNode
	"Answer the value of currentlySelectedNode"

	^ currentlySelectedNode! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 11:35'!
currentlySelectedNode: anObject
	"Set the value of currentlySelectedNode"

	currentlySelectedNode := anObject! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/2/2012 17:38'!
defineAlgorithmfor: aButtonUIElementKey with: anAlgorithmFactoryMethod
	
	self
		deselectAllAvailableAlgorithms;
		algorithmFactoryMethod: anAlgorithmFactoryMethod;
		markAlgorithmButtonAsSelected: (self uiElement: aButtonUIElementKey).


	! !

!SDNavMainWindow methodsFor: 'events' stamp: 'GNS 12/2/2012 15:30'!
deselect

	self graph nodes do: [:aNode | aNode asNormalNode.].
	self selectedStartNode ifNotNil: [self selectedStartNode asStartNode].
	self selectedEndNode ifNotNil: [self selectedEndNode asEndNode].! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/2/2012 17:37'!
deselectAllAvailableAlgorithms
	
	self uiElements
		keysDo: [:uiElementKey |
			(uiElementKey asString endsWith: 'AlgorithmBtn')
				ifTrue: [self unmarkAlgorithmButtonAsSelected: (self uiElement: uiElementKey)]. ].	! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 00:13'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 00:13'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/28/2012 01:15'!
initialize	
	
	super initialize.
	
	self
		initializeModel;
		initializeAppearance.
	  
	
	
	
	
	! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 10:11'!
initializeAppearance

	self
		setLabel: 'Navigation System';
		minimumExtent: 800@600;
		position: World center;
		initializeCanvasGraph;
		initializePanelSelect;
		initializePanelControl;
		initializePanelInformation.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/6/2012 10:21'!
initializeButtonAlgorithms: aControlPanel

	| button |
	
	button := self makeButton: 'Dijkstra' withAction: #selectDijkstraAlgorithm andState: nil onControlPanel: aControlPanel.
	button center: 380 @ (aControlPanel height / 2).
	aControlPanel addMorph: button.
	self addUIElement: button at: #DijkstraAlgorithmBtn.
	
	button := self makeButton: 'A*' withAction: #selectAStarAlgorithm andState: nil onControlPanel: aControlPanel.
	button center: 480 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: button.
	self addUIElement: button at: #AStarAlgorithmBtn.
	
	"Set the initial Algorithm"
	self selectDijkstraAlgorithm.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 09:47'!
initializeButtonPlayPauseReplay: aControlPanel

	| playPauseButton |
	
	playPauseButton := self makeButton: 'Play' withAction: #playAlgorithm andState: nil onControlPanel: aControlPanel.
	playPauseButton center: 30 @ (aControlPanel height / 2).
	aControlPanel addMorph: playPauseButton.
	self addUIElement: playPauseButton at: #PlayPauseBtn! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 15:40'!
initializeButtonStartEnd: aControlPanel

	| button |
	
	button := self makeButton: 'Set Start Point' withAction: #setStart andState: nil onControlPanel: aControlPanel.
	button center: 80 @ (aControlPanel height / 2).
	aControlPanel addMorph: button.
	self addUIElement: button at: #SetStartBtn.
	
	button := self makeButton: 'Set End Point' withAction: #setEnd andState: nil onControlPanel: aControlPanel.
	button center: 180 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: button.
	self addUIElement: button at: #SetEndBtn.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 09:47'!
initializeButtonStep: aControlPanel

	| stepButton |
	
	stepButton := self makeButton: 'Step' withAction: #stepAlgorithm andState: nil onControlPanel: aControlPanel.
	stepButton	
		center: 100 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: stepButton.
	self addUIElement: stepButton at: #StepBtn.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 16:23'!
initializeCanvasGraph
	
	self
		loadGraph;
		addUIElement: self graph at: #GraphCanvas;
		addMorph: self graph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@50 corner: 0@50 negated)).
	
	self graph
		color: Color transparent;
		drawYourselfOn: self graph;
		lock.
		
	"Define all events"
	self graph on: #click send: #value to: [self deselect].
	self graph nodes
		do: [ :aNode |
			aNode on: #click send: #value to: [self selectNode: aNode].].
	
	
		! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/30/2012 00:14'!
initializeModel

	"self model: SDNavMainWindowModel new."
	self model: Model new. ! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 09:49'!
initializePanelControl

	| controlPanel |
	
	controlPanel := Morph new.
	self addMorph: controlPanel fullFrame: (LayoutFrame fractions: (0@1 corner: 0@1) offsets: (0@50 negated corner: 150@0)).
	controlPanel color: Color lightGreen.
	
	self
		initializeButtonPlayPauseReplay: controlPanel;
		initializeButtonStep: controlPanel.
	 ! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 09:48'!
initializePanelInformation

	| informationPanel |
	
	informationPanel := Morph new.
	self addMorph: informationPanel fullFrame: (LayoutFrame fractions: (0@1 corner: 1@1) offsets: (150@50 negated corner: 0@0)).
	informationPanel color: Color lightGreen.
	
	"self
		initializePlayPauseButton: informationPanel;
		initializeStepButton: informationPanel."
	 ! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 17:29'!
initializePanelSelect

	| selectPanel |
	
	selectPanel := Morph new.
	self addMorph: selectPanel fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@50)).
	selectPanel color: Color lightGreen.
	
	self
		initializeButtonStartEnd: selectPanel;
		initializeButtonAlgorithms: selectPanel. 
	 ! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 12/6/2012 10:36'!
loadAlgorithm
	
	self algorithm: self algorithmFactoryMethod value.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 12/2/2012 11:19'!
loadGraph
	
	self graph: SDNavMediumSampleGraph new.	
		
		! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/2/2012 16:24'!
loadLittleSampleGraph

	self model graph: SDNavLittleSampleGraph new.
	self model graph drawYourselfOn: self graph.
! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/2/2012 16:24'!
loadMediumSampleGraph

	self graph: SDNavMediumSampleGraph new.
	self graph drawYourselfOn: self graph.
! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 11/20/2012 18:11'!
makeButton: aLabel withAction: anActionSymbol andState: aStateSymbol onControlPanel: aControlPanel
	
	| button |
	
	button := SimpleButtonMorph new.
   	button
		target: self;
		label: aLabel;
		actionSelector: anActionSymbol.
		
	^ button! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 12/2/2012 17:32'!
markAlgorithmButtonAsSelected: anAlgorithmButton

	anAlgorithmButton 
		borderWidth: 4;
		color: (Color r: 0.4 g: 0.8 b: 0.6) lighter lighter.! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 11/30/2012 02:10'!
pauseAlgorithm
	
	self algorithm stopStepping.
	self changePauseBtnToPlayBtn.
	
	! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/6/2012 10:38'!
playAlgorithm

	self algorithmCanPlay ifFalse: [^ self.].
	
	"When no algorithm is set, then we will create one"
	self algorithm ifNil: [self loadAlgorithm.].

	"A running algorithm should not be disturbed"
	self algorithm isStepping ifTrue: [^ self.].
	
	self algorithm startStepping.
	self changePlayBtnToPauseBtn.! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/6/2012 11:23'!
replayAlgorithm

	self graph resetYourselfOn: self graph.
	self algorithm abandon. 
	self algorithm: self algorithmFactoryMethod value..
	
	self algorithm startStepping.
	self changePlayBtnToPauseBtn.
	! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/2/2012 17:35'!
selectAStarAlgorithm

	self defineAlgorithmfor: #AStarAlgorithmBtn with: [self createAStarAlgorithm.].! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/2/2012 17:36'!
selectDijkstraAlgorithm
	
	self defineAlgorithmfor: #DijkstraAlgorithmBtn with: [self createDijkstraAlgorithm.].! !

!SDNavMainWindow methodsFor: 'events' stamp: 'GNS 12/2/2012 15:20'!
selectNode: theSelectedNode

	self graph nodes do: [:aNode | aNode asNormalNode].
	
	self currentlySelectedNode: theSelectedNode.
	
	self currentlySelectedNode asSelectedNode.
	self selectedStartNode ifNotNil: [self selectedStartNode asStartNode].
	self selectedEndNode ifNotNil: [self selectedEndNode asEndNode].! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 14:07'!
selectedEndNode
	"Answer the value of selectedEndNode"

	^ selectedEndNode! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 14:07'!
selectedEndNode: anObject
	"Set the value of selectedEndNode"

	selectedEndNode := anObject! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 14:07'!
selectedStartNode
	"Answer the value of selectedStartNode"

	^ selectedStartNode! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 12/2/2012 14:07'!
selectedStartNode: anObject
	"Set the value of selectedStartNode"

	selectedStartNode := anObject! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/2/2012 15:23'!
setEnd

	self selectedEndNode
		ifNotNil: [self selectedEndNode asNormalNode].
	self selectedEndNode: self currentlySelectedNode.
	self selectedEndNode asEndNode.! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/2/2012 15:24'!
setStart

	self selectedStartNode
		ifNotNil: [self selectedStartNode asNormalNode].
	self selectedStartNode: self currentlySelectedNode.
	self selectedStartNode asStartNode.! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 12/6/2012 10:41'!
stepAlgorithm

	self algorithmCanPlay ifFalse: [^ self.].
	
	"When no algorithm is set, then we will create one"
	self algorithm ifNil: [self loadAlgorithm.].
	
	"Stop algorithm if it's still stepping"	
	self algorithm isStepping
		ifTrue: [
			self algorithm stopStepping.
			self changePauseBtnToPlayBtn.].
	
	self algorithm isFinished
		ifTrue: [^ self.].
	
	self algorithm step.! !

!SDNavMainWindow methodsFor: 'events' stamp: 'GNS 12/2/2012 11:28'!
toggleSelect

	Transcript show: 'Hello'.! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/30/2012 02:02'!
uiElement: aKeySymbol 

	^ self uiElements at: aKeySymbol asSymbol.! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/29/2012 01:58'!
uiElements

	uiElements ifNil: [uiElements := Dictionary new.].
	^ uiElements! !

!SDNavMainWindow methodsFor: 'helping' stamp: 'GNS 12/2/2012 17:32'!
unmarkAlgorithmButtonAsSelected: anAlgorithmButton

	anAlgorithmButton 
		borderWidth: 1;
		color: (Color r: 0.4 g: 0.8 b: 0.6).! !

TestCase subclass: #SDNavDijkstraAlgorithmTestCase
	instanceVariableNames: 'startNode endNode graph distances visitedNodes unvisitedNodes predecessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavDijkstraAlgorithmTestCase methodsFor: 'tests' stamp: 'GNS 11/24/2012 02:42'!
testPlainAlgoVsSteppedAlgo

	| plainAlgo steppedAlgo testGraph |
	
	testGraph := SDNavLittleSampleGraph new.

	plainAlgo := SDNavDijkstraAlgorithm new.
	plainAlgo
		on: testGraph from: testGraph nodes first to: nil;
		execute.
	
	steppedAlgo := SDNavDijkstraAlgorithm new.
	steppedAlgo on: testGraph from: testGraph nodes first to: nil.
	1 to: 20 do: [:i | steppedAlgo step].
	
	
	self
		should: [plainAlgo startNode = steppedAlgo startNode];
		should: [plainAlgo endNode = steppedAlgo endNode];
		should: [plainAlgo distances = steppedAlgo distances];
		should: [plainAlgo visitedNodes = steppedAlgo visitedNodes];
		should: [plainAlgo unvisitedNodes = steppedAlgo unvisitedNodes];
		should: [plainAlgo predecessors = steppedAlgo predecessors].! !

!SDNavDijkstraAlgorithmTestCase methodsFor: 'tests' stamp: 'GNS 11/24/2012 03:02'!
testPlainAlgorithm
	
	| plainAlgo testGraph nodeA nodeB nodeC |
	
	testGraph := SDNavLittleSampleGraph new.
	nodeA := testGraph nodes at: 1.
	nodeB := testGraph nodes at: 2.
	nodeC := testGraph nodes at: 3.
	
	plainAlgo := SDNavDijkstraAlgorithm new.
	plainAlgo
		on: testGraph from: nodeA to: nil;
		execute.
	
	self
		should: [plainAlgo distances isDictionary];
		should: [plainAlgo distances size = 3];
		should: [(plainAlgo distances at: nodeA) = 0];
		should: [(plainAlgo distances at: nodeB) = 2];
		should: [(plainAlgo distances at: nodeC) = 4].! !

Object subclass: #SteppableSDNavObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SteppableSDNavObject methodsFor: 'as yet unclassified' stamp: 'GNS 11/29/2012 02:23'!
step

	Transcript show: 'Hello'.! !

!SteppableSDNavObject methodsFor: 'as yet unclassified' stamp: 'GNS 11/29/2012 02:23'!
wantsSteps

	^ true! !

!SteppableSDNavObject methodsFor: 'as yet unclassified' stamp: 'GNS 11/29/2012 22:54'!
wantsStepsin: hisView

	^ true! !

CircleMorph subclass: #SDNavNode
	instanceVariableNames: 'gridPosition name edges isSelected graph additionalContent label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavNode class methodsFor: 'instance creation' stamp: 'GNS 11/18/2012 15:41'!
createWithName: aName

	| node |
	
	node := SDNavNode new.
	node name: aName.		
	
	^ node ! !

!SDNavNode class methodsFor: 'instance creation' stamp: 'GNS 12/2/2012 15:26'!
createWithName: aName on: aPoint in: aGraph

	| node |
	
	node := SDNavNode new.
	node name: aName.	
	node gridPosition: aPoint.
	
	node graph: aGraph.
	
	
	^ node ! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:41'!
addConnectionTo: aNode withWeight: aWeight

	| edge |
	
	edge := SDNavEdge newWithStartNode: self andEndNode: aNode withWeight: aWeight.
	
	self edges add: edge.
	
	^ edge! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/26/2012 17:13'!
additionalContent
	"Answer the value of additionalContent"

	^ additionalContent! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/27/2012 12:21'!
additionalContent: anObject
	"Set the value of additionalContent"

	additionalContent ifNil: 
	[
		additionalContent := StringMorph.
		self addMorph: additionalContent.
		additionalContent
			fontName: self defaultFontName size: self defaultFontSize - 5;
			lock;
			center: self center + (10@10).
	]! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 15:56'!
applyInitialLabelAppearance

	self label
		contents: self name asString;
		fontName: self defaultFontName size: self defaultFontSize;
		center: self center;
		lock;
		changed.! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:19'!
applyInitialNodeAppearance: aCanvas

	self
		extent: 30@30; 
		center: aCanvas topLeft + (self gridPosition * 50);
		color: Color white;
		changed.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 14:32'!
asEndNode

	self
		borderWidth: 2.5;
		borderColor: Color red.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 14:32'!
asNormalNode

	self
		borderWidth: 1;
		borderColor: Color black.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 14:38'!
asSelectedNode

	self
		borderWidth: 4;
		borderColor: Color black.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 14:31'!
asStartNode

	self
		borderWidth: 2.5;
		borderColor: Color green.! !

!SDNavNode methodsFor: 'helping' stamp: 'GNS 12/2/2012 09:16'!
asString

	^ self name! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 11/20/2012 17:57'!
defaultFontName

	^ Preferences standardDefaultTextFont familyName! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 11/27/2012 12:34'!
defaultFontSize

	^ 14! !

!SDNavNode methodsFor: 'api' stamp: 'bg 11/20/2012 18:47'!
distanceTo: aNode

	
	self edges do: [ :edge |
		(edge endNode = aNode) ifTrue: [^ edge weights ]
		].
	^ 1000! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:18'!
drawLabel

	label := StringMorph contents: self name.
	self
		addMorph: label;
		applyInitialLabelAppearance.! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:16'!
drawMorphOn: aCanvas

	self applyInitialNodeAppearance: aCanvas.! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 11/26/2012 17:11'!
drawYourselfOn: aCanvas

	aCanvas addMorph: self. 
	
	self 
		drawMorphOn: aCanvas;
		drawLabel.! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:26'!
edges
	"Answer the value of edges"
	
	edges ifNil: [
		edges := OrderedCollection new.].
	
	^ edges! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 16:59'!
edges: anObject
	"Set the value of edges"

	edges := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 23:08'!
graph

	^graph! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 23:08'!
graph: aGraph

	graph := aGraph! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 17:13'!
gridPosition
	"Answer the value of gridposition"

	^ gridPosition! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 17:13'!
gridPosition: anObject
	"Set the value of gridposition"

	gridPosition := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 19:45'!
isSelected

	isSelected ifNil: [
		isSelected := false.].
	
	^isSelected.! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/26/2012 17:12'!
isSelected: anObject
	"Set the value of isSelected"

	isSelected := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 12/2/2012 09:02'!
label

	^ submorphs first.! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:18'!
name

	^ name! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/27/2012 09:46'!
name: anObject
	"Set the value of name"

	name := anObject.
	self updateLabel.! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:18'!
resetYourselfOn: aCanvas
	
	self
		applyInitialNodeAppearance: aCanvas;
		applyInitialLabelAppearance.! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 12/2/2012 09:19'!
updateLabel

	label ifNotNil: [label contents: self name asString.].! !
